import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;

public class TextUtility {
    public static ArrayList<String> readTextFileToList(String filename) {
        ArrayList<String> lines = new ArrayList<>();
        try {
            BufferedReader br = new BufferedReader(new FileReader(filename));
            String line;
            while ((line = br.readLine()) != null) {
                lines.add(line);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return lines;
    }
    static double[] stringArrayToDoubleArray(String[] ss){
        double[] res = new double[ss.length];
        for(int i=0;i<ss.length;i++){
            res[i] = Double.valueOf(ss[i]);
        }
        return res;
    }
    public static String[] sortListByDoubleKey(String[][] table, boolean decreasing){
        if(table[0].length != 2){
            System.err.println("sortListByIntKey: wrong dimension of input table");
            System.exit(1);
        }
        int N = table.length;
        ArrayList<ArrayList<String>> toSort = new ArrayList<>();

        for(int i=0;i<N;i++){
            ArrayList<String> temp = new ArrayList<>();
            for(int j=0;j<2;j++){
                temp.add(table[i][j]);
            }
            toSort.add(temp);
        }
        Collections.sort(toSort, new Comparator<ArrayList<String>>(){
            @Override
            public int compare(ArrayList<String> o1, ArrayList<String> o2){
                return Double.valueOf(o1.get(1)).compareTo(Double.valueOf(o2.get(1)));
            }
        });
        if(decreasing) Collections.reverse(toSort);
        String[] res = new String[N];
        for(int i=0;i<N;i++){
            res[i] = toSort.get(i).get(0);
        }
        return res;
    }
    public static HashMap<String, String> read2ColTable(String filename) {
        HashMap<String, String> table = new HashMap<>();
        try {
            BufferedReader br = new BufferedReader(new FileReader(filename));
            String line;
            while ((line = br.readLine()) != null) {
                String[] tks = line.split("\t");
                if(tks.length < 2){
                    table.put(tks[0], "");
                }
                else
                    table.put(tks[0], tks[1]);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return table;
    }
}
