public class VectorUtility {
    public static double cosineSimilarity(String vectorStringA, String vectorStringB){
        String[] tksA = vectorStringA.split(",");
        String[] tksB = vectorStringB.split(",");
        double[] vectorA = new double[tksA.length];
        double[] vectorB = new double[tksB.length];
        for(int i=0;i<tksA.length;i++){
            vectorA[i] = Double.valueOf(tksA[i]);
            vectorB[i] = Double.valueOf(tksB[i]);
        }

        double dotProduct = 0.0;
        double normA = 0.0;
        double normB = 0.0;
        for (int i = 0; i < vectorA.length; i++) {
            dotProduct += vectorA[i] * vectorB[i];
            normA += Math.pow(vectorA[i], 2);
            normB += Math.pow(vectorB[i], 2);
        }
        if(normA == 0 || normB == 0){
            //System.err.println("consine similarity error normA or normB is 0");
            return 0;
        }
        return dotProduct / (Math.sqrt(normA) * Math.sqrt(normB));
    }
    public static double mean(double[] vec){
        double sum = 0;
        int n = vec.length;
        for(double v : vec) sum += v;
        return sum/n;
    }
}
